Index: issm/trunk/src/c/solutions/prognostic_core.cpp
===================================================================
--- issm/trunk/src/c/solutions/prognostic_core.cpp	(revision 4054)
+++ issm/trunk/src/c/solutions/prognostic_core.cpp	(revision 4055)
@@ -11,52 +11,28 @@
 #include "../solvers/solvers.h"
 
-Results* prognostic_core(Model* model){
+void prognostic_core(FemModel* femmodel){
 
-	extern int my_rank;
-
-	/*output: */
-	Results* results=NULL;
-	Result*  result=NULL;
-
-	/*solutions: */
-	Vec h_g=NULL;
-
-	/*flags: */
+	/*parameters: */
 	int verbose=0;
 
-	/*fem prognostic model: */
-	FemModel* fem_p=NULL;
-
-	//initialize results
-	results=new Results();
-
-	/*recover fem model: */
-	fem_p=model->GetFormulation(PrognosticAnalysisEnum); ISSMASSERT(fem_p);
-
-	//first recover parameters common to all solutions
-	model->FindParam(&verbose,VerboseEnum);
+	/*activate formulation: */
+	femmodel->SetCurrentAnalysis(PrognosticAnalysisEnum);
+	
+	/*recover parameters: */
+	femmodel->parameters->FindParam(&verbose,VerboseEnum);
 
 	_printf_("depth averaging velocity...\n");
-	DepthAverageInputx(fem_p->elements,fem_p->nodes, fem_p->vertices,fem_p->loads, fem_p->materials,fem_p->parameters,VxEnum);
-	DepthAverageInputx(fem_p->elements,fem_p->nodes, fem_p->vertices,fem_p->loads, fem_p->materials,fem_p->parameters,VyEnum);
+	DepthAverageInputx(femmodel->elements,femmodel->nodes, femmodel->vertices,femmodel->loads, femmodel->materials,femmodel->parameters,VxEnum,VxAverageEnum);
+	DepthAverageInputx(femmodel->elements,femmodel->nodes, femmodel->vertices,femmodel->loads, femmodel->materials,femmodel->parameters,VyEnum,VyAverageEnum);
 	
 	_printf_("call computational core:\n");
-	diagnostic_core_linear(&h_g,fem_p,PrognosticAnalysisEnum,NoneAnalysisEnum);
+	solver_linear(NULL,femmodel);
 		
-	_printf_("update inputs:\n");
-	UpdateInputsFromSolutionx( fem_p->elements,fem_p->nodes, fem_p->vertices, fem_p->loads, fem_p->materials, fem_p->parameters,h_g,PrognosticAnalysisEnum,NoneAnalysisEnum);
+	_printf_("extrude computed thickness on all layers:\n");
+	ExtrudeInputx(femmodel->elements,femmodel->nodes, femmodel->vertices,femmodel->loads, femmodel->materials,femmodel->parameters,ThicknessEnum);
 
-	_printf_("extrude computed thickness on all layers:\n");
-	ExtrudeInputx(fem_p->elements,fem_p->nodes, fem_p->vertices,fem_p->loads, fem_p->materials,fem_p->parameters,ThicknessEnum);
+	if(verbose)_printf_("saving results:\n");
+	InputToResultx(femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,ThicknessEnum);
 	
-	_printf_("extract result from extruded inputs: \n");
-	InputToResultx(&result,fem_p->elements,fem_p->nodes,fem_p->vertices, fem_p->loads, fem_p->materials,fem_p->parameters,ThicknessEnum,results->Size()+1,0,1); results->AddObject(result);
-	results->AddObject(new StringResult(results->Size()+1,AnalysisTypeEnum,0,1,EnumAsString(PrognosticAnalysisEnum)));
+}
 
-	/*Free ressources:*/
-	VecFree(&h_g);
-	
-	//return: 
-	return results;
-
-}
Index: issm/trunk/src/c/solutions/solutions.h
===================================================================
--- issm/trunk/src/c/solutions/solutions.h	(revision 4054)
+++ issm/trunk/src/c/solutions/solutions.h	(revision 4055)
@@ -13,44 +13,37 @@
 
 /*cores: */
-Results* prognostic_core(FemModel* femmodel);
-Results* prognostic2_core(FemModel* femmodel);
-Results* balancedthickness_core(FemModel* femmodel);
-Results* balancedthickness2_core(FemModel* femmodel);
-Results* balancedvelocities_core(FemModel* femmodel);
-Results* slopecompute_core(FemModel* femmodel);
-Results* steadystate_core(FemModel* femmodel);
-Results* transient_core(FemModel* femmodel);
-Results* transient_core_2d(FemModel* femmodel);
-Results* transient_core_3d(FemModel* femmodel);
 void adjoint_core(FemModel* femmodel);
 void gradient_core(FemModel* femmodel,int step=0, double search_scalar=0);
 void diagnostic_core(FemModel* femmodel);
 void thermal_core(FemModel* femmodel);
-void surfaceslope_core(FemModel* femfemmodel);
-void bedslope_core(FemModel* femfemmodel);
+void thermal_core_step(FemModel* femmodel,int step, double time);
+void surfaceslope_core(FemModel* femmodel);
+void bedslope_core(FemModel* femmodel);
 void control_core(FemModel* femmodel);
+void prognostic_core(FemModel* femmodel);
+void prognostic2_core(FemModel* femmodel);
+void balancedthickness_core(FemModel* femmodel);
+void balancedthickness2_core(FemModel* femmodel);
+void balancedvelocities_core(FemModel* femmodel);
+void slopecompute_core(FemModel* femmodel);
+void steadystate_core(FemModel* femmodel);
+void transient2d_core(FemModel* femmodel);
+void transient3d_core(FemModel* femmodel);
+double objectivefunctionC(double search_scalar,OptArgs* optargs);
 
-//int GradJOrth(WorkspaceParams* workspaceparams);
+//convergence:
 void convergence(int* pconverged, Mat K_ff,Vec p_f,Vec u_f,Vec u_f_old,Parameters* parameters);
 int controlconvergence(double* J, double* fit, double eps_cm, int n);
 
-int GoldenSearch(double* psearch_scalar,double* pJ,double xa, double xb, double tolerance, int maxiter, double fit,double optscal,double (*f)(double*,double,double,FemModel*),FemModel* femfemmodel);
+//optimization
+int GoldenSearch(double* psearch_scalar,double* pJ,double xa, double xb, double tolerance, int maxiter, double fit,double optscal,double (*f)(double*,double,double,FemModel*),FemModel* femmodel);
+int BrentSearch(double* psearch_scalar,double* pJ,double xa, double xb, double tolerance, int maxiter, double fit,double optscal,double (*f)(double*,double,double,FemModel*),FemModel* femmodel);
+int GradJSearch(double* search_vector,FemModel* femmodel,int step);
 
-int BrentSearch(double* psearch_scalar,double* pJ,double xa, double xb, double tolerance, int maxiter, double fit,double optscal,double (*f)(double*,double,double,FemModel*),FemModel* femfemmodel);
-	
-double objectivefunctionC(double search_scalar,OptArgs* optargs);
-
-int GradJSearch(double* search_vector,FemModel* femfemmodel,int step);
-//int GradJCheck(WorkspaceParams* workspaceparams,int step,int status);
-
-//int ParameterUpdate(double* search_vector,int step, WorkspaceParams* workspaceparams,BatchParams* batchparams);
+//diverse
 void WriteLockFile(char* filename);
-
-void stokescontrolinit(FemModel* femfemmodel);
-void controlrestart(FemModel* femfemmodel);
-
-void CreateFemModel(FemModel* femfemmodel,ConstDataHandle MODEL,int analysis_type,int sub_analysis_type);
-//int BatchDebug(Mat* Kgg,Vec* pg,FemModel* femfemmodel,char* filename);
-void ResetBoundaryConditions(FemModel* femfemmodel, int analysis_type, int sub_analysis_type);
+void stokescontrolinit(FemModel* femmodel);
+void controlrestart(FemModel* femmodel,double* J);
+void ResetBoundaryConditions(FemModel* femmodel, int analysis_type, int sub_analysis_type);
 
 #endif
Index: issm/trunk/src/c/solutions/steadystate.cpp
===================================================================
--- issm/trunk/src/c/solutions/steadystate.cpp	(revision 4054)
+++ issm/trunk/src/c/solutions/steadystate.cpp	(revision 4055)
@@ -24,25 +24,10 @@
 	char* outputfilename=NULL;
 	char* lockname=NULL;
-	int   numberofnodes;
 	bool  qmu_analysis=false;
 	bool  control_analysis=false;
-	char* control_type=NULL;
+	bool waitonlock=false;
 
-	/*Model: */
-	Model* model=NULL;
-	FemModel* fem_dh=NULL;
-	FemModel* fem_ds=NULL;
-
-	/*Results: */
-	Results* results=NULL;
-	
-	bool waitonlock=false;
-	
-	double* u_g_initial=NULL;
-	double* p_g_initial=NULL;
-	double* u_g_obs=NULL;
-	double* weights=NULL;
-	double  dt;
-	BoolParam*  param=NULL;
+	/*FemModel: */
+	FemModel* femmodel=NULL;
 
 	/*time*/
@@ -50,4 +35,10 @@
 	double   start_core, finish_core;
 	double   start_init, finish_init;
+
+	/*intermediary: */
+	BoolParam* param=NULL;
+
+	int analyses[7]={DiagnosticHorizAnalysisEnum,DiagnosticVertAnalysisEnum,DiagnosticStokesAnalysisEnum,DiagnosticHutterAnalysisEnum,SlopeAnalysisEnum,ThermalAnalysisEnum,MeltingAnalysisEnum};
+	int solution_type=SteadystateAnalysisEnum;
 
 	MODULEBOOT();
@@ -70,32 +61,15 @@
 	lockname=argv[4];
 
+	/*Initialize model structure: */
+	MPI_Barrier(MPI_COMM_WORLD); start_init=MPI_Wtime();
+
 	/*Open handle to data on disk: */
 	fid=pfopen(inputfilename,"rb");
 
-	/*Initialize model structure: */
-	MPI_Barrier(MPI_COMM_WORLD); start_init=MPI_Wtime();
-	model=new Model();
+	_printf_("create finite element model:\n");
+	femmodel=new FemModel(fid,solution_type,analyses,5);
 
-	_printf_("read and create finite element model:\n");
-	
-	_printf_("\n   reading diagnostic horiz model data:\n");
-	model->AddFormulation(fid,DiagnosticAnalysisEnum,HorizAnalysisEnum);
-
-	_printf_("\n   reading diagnostic vert model data:\n");
-	model->AddFormulation(fid,DiagnosticAnalysisEnum,VertAnalysisEnum);
-	
-	_printf_("\n   reading diagnostic stokes model data:\n");
-	model->AddFormulation(fid,DiagnosticAnalysisEnum,StokesAnalysisEnum);
-	
-	_printf_("\n   reading diagnostic hutter model data:\n");
-	model->AddFormulation(fid,DiagnosticAnalysisEnum,HutterAnalysisEnum);
-	
-	_printf_("\n   reading surface and bed slope computation model data:\n");
-	model->AddFormulation(fid,SlopecomputeAnalysisEnum);
-
-	_printf_("\n   read and create thermal finite element model:\n");
-	model->AddFormulation(fid,ThermalAnalysisEnum);
-	_printf_("\n   read and create melting finite element model:\n");
-	model->AddFormulation(fid,MeltingAnalysisEnum);
+	/*add outputfilename in parameters: */
+	femmodel->parameters->AddObject(new StringParam(OutputFileNameEnum,outputfilename));
 
 	/*recover parameters: */
@@ -113,5 +87,5 @@
 			_printf_("call computational core:\n");
 			MPI_Barrier(MPI_COMM_WORLD); start_core=MPI_Wtime( );
-			results=steadystate_core(model);
+			steadystate_core(femmodel);
 			MPI_Barrier(MPI_COMM_WORLD); finish_core=MPI_Wtime( );
 
@@ -119,20 +93,16 @@
 		else{
 			/*change control_steady to 1 to know we are doing steadystate*/
-			fem_dh=model->GetFormulation(DiagnosticAnalysisEnum,HorizAnalysisEnum);
-			fem_ds=model->GetFormulation(DiagnosticAnalysisEnum,StokesAnalysisEnum);
-
-			param=(BoolParam*)fem_dh->parameters->FindParamObject(ControlSteadyEnum); param->value=true;
-			param=(BoolParam*)fem_ds->parameters->FindParamObject(ControlSteadyEnum); param->value=true;
+			param=(BoolParam*)femmodel->parameters->FindParamObject(ControlSteadyEnum); param->value=true;
 
 			/*run control analysis: */
 			_printf_("call computational core:\n");
 			MPI_Barrier(MPI_COMM_WORLD); start_core=MPI_Wtime( );
-			results=control_core(model);
+			control_core(femmodel);
 			MPI_Barrier(MPI_COMM_WORLD); finish_core=MPI_Wtime( );
-
 		}
 
 		_printf_("write results to disk:\n");
-		OutputResults(results,outputfilename);
+		OutputResults(femmodel->elements, femmodel->loads, femmodel->nodes, femmodel->vertices, femmodel->materials, femmodel->parameters);
+
 	}
 	else{
@@ -142,5 +112,5 @@
 		#ifdef _HAVE_DAKOTA_ 
 		MPI_Barrier(MPI_COMM_WORLD); start_core=MPI_Wtime( );
-		Qmux(model,SteadystateAnalysisEnum,NoneAnalysisEnum);
+		Qmux(femmodel,SteadystateAnalysisEnum,NoneAnalysisEnum);
 		MPI_Barrier(MPI_COMM_WORLD); finish_core=MPI_Wtime( );
 	 	#else
@@ -155,9 +125,5 @@
 	
 	/*Free ressources */
-	xfree((void**)&u_g_initial);
-	xfree((void**)&u_g_obs);
-	xfree((void**)&p_g_initial);
-	delete model;
-	delete results;
+	delete femmodel;
 
 	/*Get finish time and close*/
Index: issm/trunk/src/c/solutions/steadystate_core.cpp
===================================================================
--- issm/trunk/src/c/solutions/steadystate_core.cpp	(revision 4054)
+++ issm/trunk/src/c/solutions/steadystate_core.cpp	(revision 4055)
@@ -9,136 +9,54 @@
 #include "./solutions.h"
 #include "../modules/modules.h"
+#include "../include/include.h"
 #include "../solvers/solvers.h"
 
-Results* steadystate_core(Model* model){
+void steadystate_core(FemModel* femmodel){
 
-	extern int my_rank;
+	/*intermediary: */
+	int step; 
 
-	/*fem models: */
-	FemModel* fem_dh=NULL;
-	FemModel* fem_dv=NULL;
-	FemModel* fem_dhu=NULL;
-	FemModel* fem_ds=NULL;
-	FemModel* fem_sl=NULL;
-	FemModel* fem_t=NULL;
-	FemModel* fem_m=NULL;
+	/*parameters: */
+	int verbose;
+	int dim;
+	
+	/* recover parameters:*/
+	femmodel->parameters->FindParam(&verbose,VerboseEnum); 
+	femmodel->parameters->FindParam(&dim,DimEnum);
 
-	/*output: */
-	Results* results=NULL;
-	Results* results_thermal=NULL;
-	Results* results_diagnostic=NULL;
-
-	/*solutions: */
-	Vec u_g=NULL;
-	Vec old_u_g=NULL;
-	Vec t_g=NULL;
-	Vec t_g_average=NULL;
-	Vec old_t_g=NULL;
-	Vec p_g=NULL;
-	Vec m_g=NULL;
-	Vec du_g=NULL;
-	Vec dt_g=NULL;
-	double ndu,nu;
-	double normdt,normt;
-	double eps_rel;
-
-	/*flags: */
-	int verbose=0;
-	int isstokes=0;
-	int numberofnodes;
-	int ndof;
-	int converged;
-	int step;
-
-	/*recover fem models: */
-	fem_dh=model->GetFormulation(DiagnosticAnalysisEnum,HorizAnalysisEnum);
-	fem_dv=model->GetFormulation(DiagnosticAnalysisEnum,VertAnalysisEnum);
-	fem_ds=model->GetFormulation(DiagnosticAnalysisEnum,StokesAnalysisEnum);
-	fem_dhu=model->GetFormulation(DiagnosticAnalysisEnum,HutterAnalysisEnum);
-	fem_sl=model->GetFormulation(SlopecomputeAnalysisEnum);
-	fem_t=model->GetFormulation(ThermalAnalysisEnum);
-	fem_m=model->GetFormulation(MeltingAnalysisEnum);
-
-
-	//first recover parameters common to all solutions
-	model->FindParam(&verbose,VerboseEnum);
-	model->FindParam(&numberofnodes,NumberOfNodesEnum);
-	model->FindParam(&eps_rel,EpsResEnum);
-	model->FindParam(&isstokes,IsStokesEnum);
-
-	//initialize: 
-	converged=0;
+	/*intialize counters: */
 	step=1;
-
-	if (isstokes)ndof=4;
-	else ndof=3;
 
 	for(;;){
 	
 		if(verbose)_printf_("%s%i\n","   computing temperature and velocity for step: ",step);
+		thermal_core(femmodel);
 
-		//first compute temperature at steady state.
-		results_thermal=thermal_core(model);
+		if(verbose)_printf_("%s\n","computing depth average temperature");
+		DepthAverageInputx(femmodel->elements,femmodel->nodes, femmodel->vertices,femmodel->loads, femmodel->materials,femmodel->parameters,TemperatureEnum,TemperatureAverageEnum);
 	
-		//get t_g and m_g;
-		VecFree(&t_g);results_thermal->FindResult(&t_g,"t_g");
-		VecFree(&m_g);results_thermal->FindResult(&m_g,"m_g");
-		delete results_thermal;
+		if(verbose)_printf_("%s\n","computing new velocity");
+		diagnostic_core(femmodel);
 
-		//Add temperature to inputs.
-		//compute depth averaged temperature and add to inputs
-		VecDuplicatePatch(&t_g_average,t_g); 
-		FieldDepthAveragex( t_g_average, fem_t->elements,fem_t->nodes, fem_t->vertices,fem_t->loads, fem_t->materials,fem_t->parameters,"temperature");
-		model->UpdateInputsFromVector(t_g_average,TemperatureAverageEnum,VertexEnum);
-		model->UpdateInputsFromVector(t_g,TemperatureEnum,VertexEnum);
-		VecFree(&t_g_average); //not needed anymore
-
-		//now compute diagnostic velocity using the steady state temperature.
-		results_diagnostic=diagnostic_core(model);
-
-		//get p_g and u_g
-		VecFree(&u_g);results_diagnostic->FindResult(&u_g,"u_g");
-		VecFree(&p_g);results_diagnostic->FindResult(&p_g,"p_g");
-		delete results_diagnostic;
-
-		//convergence? 
-		if(step>1){
-			VecDuplicatePatch(&du_g,old_u_g);VecAYPX(du_g,-1.0,u_g);
-			VecNorm(du_g,NORM_2,&ndu); VecNorm(old_u_g,NORM_2,&nu); VecFree(&du_g);
-
-			VecDuplicatePatch(&dt_g,old_t_g); VecAYPX(dt_g,-1.0,t_g);
-			VecNorm(dt_g,NORM_2,&normdt); VecNorm(old_t_g,NORM_2,&normt);VecFree(&dt_g);
-					
-			if (verbose) _printf_("%-60s%g\n                                     %s%g\n                                     %s%g%s\n",
-					  "      relative convergence criterion: velocity -> norm(du)/norm(u)=   ",ndu/nu*100," temperature -> norm(dt)/norm(t)=",normdt/normt*100," eps_rel:                        ",eps_rel*100," %");
+		if(verbose)_printf_("%s\n","checking velocity, temperature and pressure convergence");
+		if (step>1) if(steadystateconvergence(femmodel))goto cleanup_and_return;
 		
-			if ((ndu/nu<=eps_rel)  && (normdt/normt<=eps_rel)) converged=1;
-			else converged=0;
-		}
-		else{
-			converged=0;
-		}
-
-		VecFree(&old_u_g);VecDuplicatePatch(&old_u_g,u_g);
-		VecFree(&old_t_g);VecDuplicatePatch(&old_t_g,t_g);
-
+		if(verbose)_printf_("%s\n","saving velocity, temperature and pressure to check for convergence at next step");
+		DuplicateInputx(femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,VxEnum,OldVxEnum);
+		DuplicateInputx(femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,VyEnum,OldVyEnum);
+		if(dim==3)DuplicateInputx(femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,VzEnum,OldVzEnum);
+		DuplicateInputx(femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,PressureEnum,OldPressureEnum);
+		DuplicateInputx(femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,TemperatureEnum,OldTemperatureEnum);
+		
+		//increase counter
 		step++;
-		if (converged)break;
 	}
 
-	/*Plug results into output dataset: */
-	results->AddObject(new Result(results->Size()+1,0,1,"u_g",u_g));
-	results->AddObject(new Result(results->Size()+1,0,1,"p_g",p_g));
-	results->AddObject(new Result(results->Size()+1,0,1,"t_g",t_g));
-	results->AddObject(new Result(results->Size()+1,0,1,"m_g",m_g));
-	results->AddObject(new StringResult(results->Size()+1,AnalysisTypeEnum,0,1,EnumAsString(SteadyAnalysisEnum)));
-
-
-	/*Free ressource*/
-	VecFree(&old_u_g);
-	VecFree(&old_t_g);
-	VecFree(&u_g);
-	VecFree(&p_g);
-	VecFree(&t_g);
-	VecFree(&m_g);
+	cleanup_and_return:
+	
+	if(verbose)_printf_("saving results:\n");
+	InputToResultx(femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,VxEnum);
+	InputToResultx(femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,VyEnum);
+	InputToResultx(femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,PressureEnum);
+	if(dim==3) InputToResultx(femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,VxEnum);
 }
Index: issm/trunk/src/c/solutions/steadystateconvergence.cpp
===================================================================
--- issm/trunk/src/c/solutions/steadystateconvergence.cpp	(revision 4055)
+++ issm/trunk/src/c/solutions/steadystateconvergence.cpp	(revision 4055)
@@ -0,0 +1,36 @@
+/*!\file: steadystateconvergence.cpp
+ * \brief: determine convergence of steady state solution
+ */ 
+
+#ifdef HAVE_CONFIG_H
+	#include "config.h"
+#else
+#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+#endif
+
+int steadystateconvergence(FemModel* femmodel){
+	
+	/*output: */
+	int converged=0;
+	int velocity_converged=0;
+	int temperature_converged=0;
+
+	/*intermediary: */
+	int velocityenums[8]={VxEnum,OldVxEnum,VyEnum,OldVyEnum,VzEnum,OldVzEnum,PressureEnum,OldPressureEnum}; //pairs of enums (new and old) on which to carry out the converence tests
+	int temperatureenums[2]={TemperatureEnum,OldTemperatureEnum};
+	int convergencecriterion[1]={RelativeEnum}; //criterions for convergence, RelativeEnum or AbsoluteEnum 
+	int convergencecriterionvalue[1]; //value of criterion to be respected
+
+	/*retrieve parameters: */
+	femmodel->parameters->FindParam(&convergencecriterionvalue[0],EpsRelEnum);
+	
+	/*figure out convergence at the input level, because we don't have the solution vectors!: */
+	velocity_converged=InputConvergencex(femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,velocityenums,8,convergencecriterion,convergencecriterionvalue,1);
+	temperature_converged=InputConvergencex(femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,temperatureenums,2,convergencecriterion,convergencecriterionvalue,1);
+
+	if(velocity_converged && temperature_converged)converged=1;
+
+	/*return: */
+	return converged;
+
+}
Index: issm/trunk/src/c/solutions/stokescontrolinit.cpp
===================================================================
--- issm/trunk/src/c/solutions/stokescontrolinit.cpp	(revision 4054)
+++ issm/trunk/src/c/solutions/stokescontrolinit.cpp	(revision 4055)
@@ -18,15 +18,16 @@
 	int isstokes=0;
 	double stokesreconditioning;
-
+	bool conserve_loads=true;
+	
 	/*first recover parameters common to all solutions:*/
-	model->FindParam(&verbose,VerboseEnum);
-	model->FindParam(&isstokes,IsStokesEnum);
-	model->FindParam(&stokesreconditioning,StokesReconditioningEnum);
+	femmodel->parameters->FindParam(&verbose,VerboseEnum);
+	femmodel->parameters->FindParam(&isstokes,IsStokesEnum);
+	femmodel->parameters->FindParam(&stokesreconditioning,StokesReconditioningEnum);
 
 	/*if no Stokes analysis carried out, assign output and return*/
-	if (!isstokes)femmodel->SetAnalysisType(DiagnosticAnalysisEnum,DiagnosticHorizAnalysisEnum);
+	if (!isstokes)femmodel->SetCurrentAnalysis(DiagnosticHorizAnalysisEnum);
 
 	/* For Stokes inverse control method, we are going to carry out the inversion only on the Stokes part. So we need 
-	 * to solve the Hutter or MacAyeal/Pattyn model here, and constrain the Stokes model using the Hutter 
+	 * to solve the Hutter or MacAyeal/Pattyn femmodel here, and constrain the Stokes femmodel using the Hutter 
 	 * or MacAyeal/Pattyn at the boundary. We don't want to have to do that at every inversion step, as 
 	 * it needs be done only once: */
@@ -36,8 +37,9 @@
 	
 	/*Run a complete diagnostic to update the Stokes spcs: */
-	solver_diagnostic_nonlinear(NULL,NULL,NULL,femmodel,false,DiagnosticAnalysisEnum,HorizAnalysisEnum); //false means we expose loads to changes inside the solution
+	femmodel->SetCurrentAnalysis(DiagnosticHorizAnalysisEnum);
+	solver_diagnostic_nonlinear(NULL,NULL,NULL,femmodel,conserve_loads);
 
 	//vertical velocity
-	solver_linear(NULL,femmodel,DiagnosticAnalysisEnum,VertAnalysisEnum);
+	solver_linear(NULL,femmodel);
 
 	//recondition" pressure computed previously:
@@ -49,7 +51,5 @@
 
 	if(verbose)_printf_("%s\n"," computing stokes velocities and pressure ...");
-	solver_diagnostic_nonlinear(NULL,NULL,NULL,NULL,femmodel,DiagnosticAnalysisEnum,StokesAnalysisEnum);
-
-	/*Assign output*/
-	model->SetActiveFormulation(fem_ds);
+	femmodel->SetCurrentAnalysis(DiagnosticStokesAnalysisEnum);
+	solver_diagnostic_nonlinear(NULL,NULL,NULL,femmodel,conserve_loads);
 }
Index: issm/trunk/src/c/solutions/surfaceslope.cpp
===================================================================
--- issm/trunk/src/c/solutions/surfaceslope.cpp	(revision 4054)
+++ issm/trunk/src/c/solutions/surfaceslope.cpp	(revision 4055)
@@ -37,6 +37,6 @@
 	double   start_init, finish_init;
 
-	int analyses[1]={SurfaceSlopeComputeAnalysisEnum};
-	int solution_type=SurfaceSlopeComputeSolutionEnum;
+	int analyses[1]={SlopeAnalysisEnum};
+	int solution_type=SlopeAnalysisEnum;
 
 	MODULEBOOT();
@@ -67,4 +67,7 @@
 	_printf_("create finite element model, using analyses types statically defined above:\n");
 	femmodel=new FemModel(fid,solution_type,analyses,1);
+
+	/*add outputfilename in parameters: */
+	femmodel->parameters->AddObject(new StringParam(OutputFileNameEnum,outputfilename));
 	
 	/*get parameters: */
@@ -83,5 +86,5 @@
 
 		_printf_("write results to disk:\n");
-		OutputResults(femmodel,outputfilename,DiagnosticAnalysisEnum);
+		OutputResults(femmodel->elements, femmodel->loads, femmodel->nodes, femmodel->vertices, femmodel->materials, femmodel->parameters);
 	}
 	else{
@@ -92,5 +95,5 @@
 		#ifdef _HAVE_DAKOTA_ 
 		MPI_Barrier(MPI_COMM_WORLD); start_core=MPI_Wtime( );
-		Qmux(femmodel,SlopeComputeAnalysisEnum,NoneAnalysisEnum);
+		Qmux(femmodel,SurfaceSlopeAnalysisEnum,NoneAnalysisEnum);
 		MPI_Barrier(MPI_COMM_WORLD); finish_core=MPI_Wtime( );
 	 	#else
Index: issm/trunk/src/c/solutions/surfaceslope_core.cpp
===================================================================
--- issm/trunk/src/c/solutions/surfaceslope_core.cpp	(revision 4054)
+++ issm/trunk/src/c/solutions/surfaceslope_core.cpp	(revision 4055)
@@ -25,12 +25,19 @@
 
 	/*Call on core computations: */
-	solver_linear(NULL,femmodel,SlopeComputeAnalysisEnum,SurfaceSlopeXAnalysisEnum);
-	solver_linear(NULL,femmodel,SlopeComputeAnalysisEnum,SurfaceSlopeYAnalysisEnum);
+	femmodel->SetCurrentAnalysisAlias(SlopeAnalysisEnum,SurfaceSlopeXAnalysisEnum);
+	solver_linear(NULL,femmodel);
+	femmodel->SetCurrentAnalysisAlias(SlopeAnalysisEnum,SurfaceSlopeYAnalysisEnum);
+	solver_linear(NULL,femmodel);
 	
 	/*extrude inputs if we are in 3D: */
 	if (dim==3){
 		if(verbose)_printf_("%s\n","extruding slope in 3d...");
-		InputsExtrudex( femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,SurfaceSlopeXEnum,0);
-		InputsExtrudex( femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,SurfaceSlopeYEnum,0);
+		ExtrudeInputx(femmodel->elements,femmodel->nodes, femmodel->vertices,femmodel->loads, femmodel->materials,femmodel->parameters,SurfaceSlopeXEnum);
+		ExtrudeInputx(femmodel->elements,femmodel->nodes, femmodel->vertices,femmodel->loads, femmodel->materials,femmodel->parameters,SurfaceSlopeYEnum);
 	}
+	
+	if(verbose)_printf_("saving results:\n");
+	InputToResultx(femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,SurfaceSlopeXEnum);
+	InputToResultx(femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,SurfaceSlopeYEnum);
+
 }
Index: issm/trunk/src/c/solutions/thermal.cpp
===================================================================
--- issm/trunk/src/c/solutions/thermal.cpp	(revision 4054)
+++ issm/trunk/src/c/solutions/thermal.cpp	(revision 4055)
@@ -68,4 +68,7 @@
 	femmodel=new FemModel(fid,solution_type,analyses,2);
 
+	/*add outputfilename in parameters: */
+	femmodel->parameters->AddObject(new StringParam(OutputFileNameEnum,outputfilename));
+
 	/*get parameters: */
 	femmodel->parameters->FindParam(&qmu_analysis,QmuAnalysisEnum);
@@ -85,5 +88,5 @@
 		
 		_printf_("write results to disk:\n");
-		OutputResults(femmodel->elements, femmodel->loads, femmodel->nodes, femmodel->vertices, femmodel->materials, femmodel->parameters, outputfilename);
+		OutputResults(femmodel->elements, femmodel->loads, femmodel->nodes, femmodel->vertices, femmodel->materials, femmodel->parameters);
 
 	}
Index: issm/trunk/src/c/solutions/thermal_core.cpp
===================================================================
--- issm/trunk/src/c/solutions/thermal_core.cpp	(revision 4054)
+++ issm/trunk/src/c/solutions/thermal_core.cpp	(revision 4055)
@@ -42,9 +42,6 @@
 		time=(i+1)*dt;
 
-		if(verbose)_printf_("computing temperatures:\n");
-		solver_thermal_nonlinear(NULL,NULL,femmodel,ThermalAnalysisEnum,NoneAnalysisEnum);
-
-		if(verbose)_printf_("computing melting:\n");
-		solver_linear(NULL,femmodel,MeltingAnalysisEnum,NoneAnalysisEnum);
+		/*call thermal_core_step: */
+		thermal_core_step(femmodel,i,time);
 
 		if(verbose)_printf_("saving results:\n");
Index: issm/trunk/src/c/solutions/thermal_core_step.cpp
===================================================================
--- issm/trunk/src/c/solutions/thermal_core_step.cpp	(revision 4055)
+++ issm/trunk/src/c/solutions/thermal_core_step.cpp	(revision 4055)
@@ -0,0 +1,26 @@
+/*!\file: thermal_core_step.cpp
+ * \brief: core of the thermal solution 
+ */ 
+
+#include "../toolkits/toolkits.h"
+#include "../objects/objects.h"
+#include "../shared/shared.h"
+#include "../EnumDefinitions/EnumDefinitions.h"
+#include "./solutions.h"
+#include "../modules/modules.h"
+#include "../include/include.h"
+#include "../solvers/solvers.h"
+
+void thermal_core_step(FemModel* femmodel,int step, double time){
+
+	//first recover parameters common to all solutions
+	femmodel->parameters->FindParam(&verbose,VerboseEnum);
+
+	if(verbose)_printf_("computing temperatures:\n");
+	femmodel->SetCurrentAnalysis(ThermalAnalysisEnum);
+	solver_thermal_nonlinear(NULL,NULL,femmodel);
+
+	if(verbose)_printf_("computing melting:\n");
+	femmodel->SetCurrentAnalysis(MeltingAnalysisEnum);
+	solver_linear(NULL,femmodel);
+}
